var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/utils/date-validation/index.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Checkbox from "../checkboxs/Checkbox";
import SearchableSelect from "../selects/SearchableSelect";
import EmailSelects from '../../utils/date-validation/EmailSelects';
import TextInput from "../inputs/TextInput";
import { makeStyles } from "@material-ui/core/styles";
import RichTextEditor from "../../utils/rich-text-editor";
import { useEffect, useState } from 'react';
import { Grid } from '@material-ui/core';
import { Modal, Button } from '@material-ui/core';
import { FormLabel, FormControl, FormHelperText } from '@material-ui/core';
import { updateEditData } from '../../actions/formActions';
import { useSelector } from 'react-redux';
import { useDispatch } from 'react-redux';
var dateValidationLabel = {
  en: 'Set Date Validation',
  ar: 'تحديد تاريخ التحقق من الصحة'
};
var reminderNotificationLabel = {
  en: 'Set Reminder/Notification',
  ar: 'تعيين تذكير / إعلام'
};
var reminderNotificationEmailLabel = {
  en: 'Reminder/Notification Email',
  ar: 'بريد إلكتروني للتذكير / الإخطار'
};
var emailSentUserParameter = {
  en: 'Email sent to users based on set parameters.',
  ar: 'تم إرسال البريد الإلكتروني إلى المستخدمين بناءً على المعلمات المحددة.'
};
var PLEASE_SELECT_RECIPIENTS = {
  en: 'Recipients ',
  ar: 'المستلمون'
};
var PLEASE_SELECT_CC = {
  en: 'CC',
  ar: 'نسخة'
};
var PLEASE_SELECT_BCC = {
  en: 'BCC',
  ar: 'نسخة مخفية الوجهة'
};
var setPastDateLabel = {
  en: 'Set Past Date',
  ar: 'تعيين التاريخ الماضي'
};
var setFutureDateLabel = {
  en: 'Set Future Date',
  ar: 'تحديد موعد في المستقبل'
};
var unitLabel = {
  en: 'Unit',
  ar: 'وحدة'
};
var minLabel = {
  en: 'Min',
  ar: 'دقيقة'
};
var maxLabel = {
  en: 'Max',
  ar: 'الأعلى'
};
var dayLabel = {
  en: 'Days',
  ar: 'أيام'
};
var monthLabel = {
  en: 'Months',
  ar: 'الشهور'
};
var yearLabel = {
  en: 'Years',
  ar: 'سنوات'
};
var afterDateLabel = {
  en: 'After Selected Date',
  ar: 'بعد التاريخ المحدد'
};
var beforeDateLabel = {
  en: 'Before Selected Date',
  ar: 'قبل التاريخ المحدد'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var updateLabel = {
  en: 'Update',
  ar: 'تحديث'
};
var useStyles = makeStyles(function (theme) {
  return {
    ahfb_para_st: {
      fontSize: '1.4rem !important',
      fontFamily: "\"Roboto\", \"Helvetica\", \"Arial\", sans-serif",
      fontWeight: '700 !important',
      lineHeight: '1.5 !important',
      letterSpacing: '0.00938em !important',
      paddingTop: '18px'
    },
    ahfb_para_st_email: {
      fontSize: '1.4rem !important',
      fontFamily: "\"Roboto\", \"Helvetica\", \"Arial\", sans-serif",
      fontWeight: '400 !important',
      lineHeight: '1.5 !important',
      letterSpacing: '0.00938em !important',
      marginTop: '-5px'
    },
    ahfb_editor_st: {
      top: '25% !important',
      left: '30% !important',
      width: '40% !important',
      position: 'absolute !important'
    },
    ahfb_editor_box: {
      background: '#fff',
      padding: '25px 25px 70px 25px',
      borderRadius: '8px'
    },
    ahfb_editor_btn_box: {
      "float": 'right'
    },
    ahfb_btn_primary: {
      color: '#3f51b5',
      border: '1px solid rgba(63, 81, 181, 0.5)',
      background: 'white',
      padding: '8px 20px',
      borderRadius: '4px',
      marginTop: '15px',
      marginRight: '0.5rem !important'
    },
    ahfb_btn_secondary: {
      color: '#fff',
      border: '1px solid rgba(63, 81, 181, 0.5)',
      background: '#3f51b5',
      padding: '8px 20px',
      borderRadius: '4px',
      marginTop: '15px',
      marginRight: '0.5rem !important'
    },
    ahfb_emails_st: {
      marginTop: '12px !important',
      marginBottom: '12px !important'
    }
  };
});

function DateValidation(props) {
  var _props$errors, _props$errors$pastLim, _props$errors2, _props$errors2$pastLi, _props$errors3, _props$errors3$future, _props$errors4, _props$errors4$future;

  var classes = useStyles();

  var _React$useState = React.useState(null),
      anchorEl = _React$useState[0],
      setAnchorEl = _React$useState[1];

  var sendTo = props.sendTo,
      sendToExternal = props.sendToExternal,
      cc = props.cc,
      ccExternal = props.ccExternal,
      bcc = props.bcc,
      bccExternal = props.bccExternal,
      handleChange = props.handleChange,
      roles = props.roles,
      error = props.error;
  var open = Boolean(anchorEl);
  var id = open ? 'simple-popper' : undefined;
  var durationOptions = [{
    label: dayLabel[props.currentLang],
    value: 'days'
  }, {
    label: monthLabel[props.currentLang],
    value: 'months'
  }, {
    label: yearLabel[props.currentLang],
    value: 'years'
  }];
  var selectedDateOptions = [{
    label: afterDateLabel[props.currentLang],
    value: 'after'
  }, {
    label: beforeDateLabel[props.currentLang],
    value: 'before'
  }];

  var _React$useState2 = React.useState(false),
      opens = _React$useState2[0],
      setOpens = _React$useState2[1];

  var handleEditor = function handleEditor() {
    return setOpens(!opens);
  };

  var editData = useSelector(function (state) {
    return state.form.editData;
  });
  var dispatch = useDispatch();
  console.log("editData", editData);

  var handleEmailsChange = function handleEmailsChange(name, internal, external) {
    if (name === 'send_to') {
      var newState = _extends({}, editData, {
        send_to: internal,
        send_to_external: external
      });

      dispatch(updateEditData(newState));
    } else if (name === 'cc') {
      var _newState = _extends({}, editData, {
        cc: internal,
        cc_external: external
      });

      dispatch(updateEditData(_newState));
    } else if (name === 'bcc') {
      var _newState2 = _extends({}, editData, {
        bcc: internal,
        bcc_external: external
      });

      dispatch(updateEditData(_newState2));
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 198,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement("row", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 199,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: props.shouldDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldDateValidate');
    },
    label: dateValidationLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 200,
      columnNumber: 9
    }
  }), props.shouldDateValidate ? /*#__PURE__*/React.createElement(Grid, {
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 202,
      columnNumber: 11
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    className: "mb-2",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 203,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: props.shouldPastDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldPastDateValidate');
    },
    label: setPastDateLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 204,
      columnNumber: 15
    }
  })), props.shouldPastDateValidate && /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 3,
    className: "mt-4",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 207,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 208,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(SearchableSelect, {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastUnit');
    },
    value: props.pastUnit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 209,
      columnNumber: 19
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 211,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 212,
      columnNumber: 19
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.pastMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMin');
    },
    error: (_props$errors = props.errors) == null ? void 0 : (_props$errors$pastLim = _props$errors.pastLimitValidation) == null ? void 0 : _props$errors$pastLim.min,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 213,
      columnNumber: 21
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 215,
      columnNumber: 19
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.pastMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'pastMax');
    },
    error: (_props$errors2 = props.errors) == null ? void 0 : (_props$errors2$pastLi = _props$errors2.pastLimitValidation) == null ? void 0 : _props$errors2$pastLi.max,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 216,
      columnNumber: 21
    }
  })))), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    className: "mb-2",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 221,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: props.shouldFutureDateValidate,
    handleChange: function handleChange(val) {
      return props.handleChange(val, 'shouldFutureDateValidate');
    },
    label: setFutureDateLabel[props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 222,
      columnNumber: 15
    }
  })), props.shouldFutureDateValidate && /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 3,
    className: "mt-4",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 225,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 226,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(SearchableSelect, {
    label: unitLabel[props.currentLang],
    options: durationOptions,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureUnit');
    },
    value: props.futureUnit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 227,
      columnNumber: 19
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 229,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 230,
      columnNumber: 19
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    type: "number",
    label: minLabel[props.currentLang],
    value: props.futureMin,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMin');
    },
    error: (_props$errors3 = props.errors) == null ? void 0 : (_props$errors3$future = _props$errors3.futureLimitValidation) == null ? void 0 : _props$errors3$future.min,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 231,
      columnNumber: 21
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 6,
    className: "ahfb-pl-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 233,
      columnNumber: 19
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    type: "number",
    label: maxLabel[props.currentLang],
    value: props.futureMax,
    handleChange: function handleChange(e) {
      return props.handleChange(e.target.value, 'futureMax');
    },
    error: (_props$errors4 = props.errors) == null ? void 0 : (_props$errors4$future = _props$errors4.futureLimitValidation) == null ? void 0 : _props$errors4$future.max,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 234,
      columnNumber: 21
    }
  }))))) : ""), /*#__PURE__*/React.createElement("br", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 243,
      columnNumber: 7
    }
  }), /*#__PURE__*/React.createElement("row", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 245,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(Checkbox, {
    checked: props == null ? void 0 : props.isReminder,
    handleChange: function handleChange(val) {
      return props == null ? void 0 : props.handleReminderChange(val == true ? 1 : 0, 'isReminder');
    },
    label: reminderNotificationLabel[props == null ? void 0 : props.currentLang],
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 246,
      columnNumber: 9
    }
  }), props.isReminder ? /*#__PURE__*/React.createElement(Grid, {
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 250,
      columnNumber: 11
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    className: classes.ahfb_emails_st,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 251,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    xs: 12,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 252,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(EmailSelects, {
    sendTo: editData.send_to,
    sendToExternal: editData.send_to_external,
    cc: editData.cc,
    ccExternal: editData.cc_external,
    bcc: editData.bcc,
    bccExternal: editData.bcc_external,
    handleChange: handleEmailsChange,
    errors: props.errors,
    roles: roles,
    error: props.errors.send_to,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 253,
      columnNumber: 17
    }
  }))), /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 3,
    className: "mt-4",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 316,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 317,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 3,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 318,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 319,
      columnNumber: 19
    }
  }, /*#__PURE__*/React.createElement(TextInput, {
    type: 'text',
    handleChange: function handleChange(e) {
      return props.handleReminderChange(Number.isInteger(parseInt(e.target.value)) ? e.target.value : '', 'quantity');
    },
    value: props.reminderLogic.quantity,
    inputProps: {
      maxLength: 3
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 320,
      columnNumber: 21
    }
  }))), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 4,
    className: "ahfb-pr-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 331,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(SearchableSelect, {
    options: durationOptions,
    handleChange: function handleChange(e) {
      var _e$target;

      return props.handleReminderChange(e == null ? void 0 : (_e$target = e.target) == null ? void 0 : _e$target.value, 'type');
    },
    value: props.reminderLogic.type,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 332,
      columnNumber: 19
    }
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 5,
    className: "ahfb-pl-1",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 334,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(SearchableSelect, {
    options: selectedDateOptions,
    handleChange: function handleChange(e) {
      var _e$target2;

      return props.handleReminderChange(e == null ? void 0 : (_e$target2 = e.target) == null ? void 0 : _e$target2.value, 'conditions');
    },
    value: props.reminderLogic.conditions,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 335,
      columnNumber: 19
    }
  }), "  "))), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 340,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement("label", {
    className: "ahfb-mt-3 ahfb-align-center",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 341,
      columnNumber: 15
    }
  }, reminderNotificationEmailLabel[props.currentLang], /*#__PURE__*/React.createElement("svg", {
    onClick: handleEditor,
    "class": "MuiSvgIcon-root MuiSvgIcon-colorAction MuiSvgIcon-fontSizeSmall text-inline",
    focusable: "false",
    viewBox: "0 0 24 24",
    "aria-hidden": "true",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 342,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement("path", {
    d: "M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34a.9959.9959 0 00-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 342,
      columnNumber: 186
    }
  })))), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    container: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 347,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement("label", {
    className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 348,
      columnNumber: 15
    }
  }, emailSentUserParameter[props.currentLang]), /*#__PURE__*/React.createElement("div", {
    style: opens ? {
      display: 'block'
    } : {
      display: 'none'
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 351,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(RichTextEditor, {
    data: props.reminderLogic.template_html,
    handleChange: function handleChange(data) {
      return props.handleReminderChange(data, 'template_html');
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 352,
      columnNumber: 17
    }
  })))) : ""));
}

export default DateValidation;